//*****************************************************************************
//              \ /
// No Copyright (c) 2003
//              / \
// No rights reserved. This material contains published,
// non-copyrighted work, which includes non-confidential and
// non-proprietary information of Kurt Santel.
//
// Source: CodeWarTypes.h
//
// Description: Common header file with the types that are common to
//              the client and the server
//
//*****************************************************************************

#pragma once

#include <utility>

////////////////////////////////////////////////////////////////////
// The values

enum Values
{
    // Arena specific values
    valMaxFoodSquares = 10,     // Maximum number of food squares
    valMaxLifeSquares = 10,     // Maximum number of life squares

    // Robot specific values
    valMaxLife = 100,           // Maximum life value
    valMaxFood = 100,           // Maximum food value
    valRest = 1,                // If you do nothing, 1 is added to your life
    valHunger = -1,             // Walking reduces food with 1
    valWalk = -1,               // Walking reduces life with 1
    valShoot = -10,             // Getting shot reduces life with 10
    valStarve = -10,            // If food == 0, starvation starts
    valEat = 10,                // Add 10 to food when we are eating
    valAttacking = -1           // Reduce life with 1 if the robot is attacking
};

////////////////////////////////////////////////////////////////////
// typedefs

typedef enum Command
{
    // Client -> Server
    cmdSkipTurn = 0,
    cmdRest,
    cmdRegister,
    cmdMoveForward,
    cmdMoveBackward,
    cmdTurnLeft,
    cmdTurnRight,
    cmdEat,
    cmdFight,

    // Server -> Client
    cmdInfo = 500,
    cmdGeneralInfo,
    cmdPoll,

    // Events, Server -> Client
    cmdDead = 1000,
    cmdHitWall,
    cmdRobotInSight,
    cmdFoodFound,
    cmdAttacked
} CommandType;

typedef char VersionType;

typedef unsigned __int64 NrType;

typedef unsigned int XType;
typedef unsigned int YType;
typedef std::pair<XType, YType> PositionType;

typedef enum Heading
{
    North = 0,
    East,
    South,
    West
} HeadingType;

typedef unsigned int IDType;
typedef char AttackType;
typedef char DefenseType;
typedef char FoodType;
typedef char LifeType;

////////////////////////////////////////////////////////////////////
// The one and only version

const VersionType theVersion = 0x01;
