#pragma once

#include <d3dx8mesh.h>

class D3DSphere
{
public:
    D3DSphere( COLORREF color = RGB( 255, 255, 0 ) );
    ~D3DSphere(void);

    bool create(IDirect3DDevice8 * pd3dDevice);

    bool changeColor( COLORREF color );

    void move(float x, float y, float z);
    void scale(float x, float y, float z);

    bool draw(void);

private:
    IDirect3DDevice8 * m_pd3dDevice;

    struct Vertex
    {
        float x, y, z; // Position of vertex in 3D space
        DWORD diffuse; // Diffuse color of vertex
    };

    COLORREF m_Color;

    LPD3DXMESH m_pSphereMesh;

    D3DXMATRIX m_mMove;
    D3DXMATRIX m_mScale;
};
